// ---------------------------------------------------------------------------------------
// gƂՂ낶ƁHh
// uƂ炢񂮂n[g uuᔠvf[^Ro[^
//                          for uӂ for ^PocketPCv
//
//                             Copyright 2001, K.Takagi(Kenjo)
//
//  TRHBCONV.C   C
// ---------------------------------------------------------------------------------------

#include "wavtable.h"
#include "trhbconv.h"
#include "lzo1x.h"

#define _VERSION_ "0.10"

//#define LOG printf						// Op
#define LOG
#define OUT_BUFFER_SIZE 65536			// SEENxxx.TXT pobt@TCY

static char		FindFile[MAX_PATH];		// t@Cp
static HANDLE	FindHandle = 0;

static char		SIO[1000][MAX_PATH];	// SIOt@CXg
static int		MaxSeen = 0;			// SIOt@C

static unsigned char SIOBuf[65536];		// SIOǂݍ݃obt@i64k͒Ȃ̂łOKj
static int SIOPtr = 0;					// ݂SIO̓|C^

static unsigned char OutBuf[OUT_BUFFER_SIZE];	// SEENxxx.TXTo̓obt@
static int OutPtr = 0;							// ݏo͒̃|C^

static unsigned char ArcBuf[0x100000];	// A[JCuobt@
static unsigned char ArcWork[LZO1X_999_MEM_COMPRESS];	// LZOobt@
static int		ArcNum = 0;				// AVDt@C̃A[JCu
static ARCHEAD	archead[4096];			// AVDA[JCuwb_
static FILE*	filep;					// AVDt@Cnh
static char		TmpFile[MAX_PATH];		// AVD쐬̃e|t@C

static JUMPTABLE JmpTable[65536];		// [JWvpiȂj
static JUMPTABLE Jmps[256];
static int JTMax = 0, JmpMax = 0;

// SEENxxx.TXT ̃wb_iAVG3216Mnj
static const unsigned char SeenBase[0x63] = {
	0x54, 0x50, 0x43, 0x33, 0x32, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x01, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00
};

static int Terminate = 0;

// --------------------------------------------------------------------------
//   ܂
// --------------------------------------------------------------------------
static void ConvertCapital(unsigned char* buf)
{
	for ( ; *buf; buf++) {
		if ( ((*buf>=0x80)&&(*buf<=0x9f))||(*buf>=0xe0) ) buf++;
		else if ( (*buf>='a')&&(*buf<='z') ) *buf -= 0x20;
	}
}


static void CutExt(char* buf)
{
	for ( ; *buf; buf++) {
		if ( *buf=='.' ) *buf = 0;
	}
}


// --------------------------------------------------------------------------
//   WinȂł͂̏
// --------------------------------------------------------------------------
// CXg[tH_擾
int SelectBaseDir(char* path)
{
	BROWSEINFO bi;
	LPCITEMIDLIST item;
	char buf[MAX_PATH];

	memset(&bi, 0, sizeof(BROWSEINFO));
	path[0] = 0;
	bi.hwndOwner = 0;
	bi.pszDisplayName  = buf;
	bi.lpszTitle = "Q[tH_̑I";

	item = SHBrowseForFolder(&bi);
	if ( !item ) {
		memset(path, 0, MAX_PATH);
		return FALSE;
	}
	if ( !SHGetPathFromIDList(item, path) ) {
		memset(path, 0, MAX_PATH);
		return FALSE;
	}

	strcat(path, "\\");
	return TRUE;
}


// Dir̎̃t@C
static char* GetDirNext(void)
{
	WIN32_FIND_DATA fd;

	memset(&fd, 0, sizeof(WIN32_FIND_DATA));
	memset(FindFile, 0, MAX_PATH);

	if ( !FindHandle ) return 0;
	while ( FindNextFile(FindHandle, &fd) ) {
		if ( !(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY) ) {
			strcpy(FindFile, fd.cFileName);
			return FindFile;
		}
	}
	FindClose(FindHandle);
	FindHandle = 0;
	return 0;
}


// Dir̍ŏ̃t@C
static char* GetDir(char* dir)
{
	WIN32_FIND_DATA fd;
	char buf[MAX_PATH];
	HANDLE h;

	memset(&fd, 0, sizeof(WIN32_FIND_DATA));
	memset(FindFile, 0, MAX_PATH);
	sprintf(buf, "%s", dir);
	if ( FindHandle ) FindClose(FindHandle);
	FindHandle = 0;
	
	h = FindFirstFile(buf, &fd);
	if ( h!=INVALID_HANDLE_VALUE ) {
		FindHandle = h;
		if ( fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY ) {
			return GetDirNext();
		} else {
			strcpy(FindFile, fd.cFileName);
			return FindFile;
		}
	}
	return 0;
}


// --------------------------------------------------------------------------
//   A[JCut@CǗ
// --------------------------------------------------------------------------
// 
int InitArc(char* p)
{
	if ( lzo_init()!=LZO_E_OK )
		return FALSE;
	sprintf(TmpFile, "%stmp.dat", p);
	filep = fopen(TmpFile, "wb");
	if ( !filep ) {
		return FALSE;
	}
	return TRUE;
}


// I
void CloseArc(char* file, AVGDATA_HEADER* head)
{
	FILE* fp;
	int i, j, len;
	ARCHEAD tmp;

	// ł̌xグ邽߁Awb_̃t@C\[gĂ
	for (i=ArcNum-1; i>0; i--) {
		for (j=0; j<i; j++) {
			if ( strcmp(archead[j].file, archead[j+1].file)>0 ) {
					memcpy(&tmp, &archead[j], 32);
					memcpy(&archead[j], &archead[j+1], 32);
					memcpy(&archead[j+1], &tmp, 32);
			}
		}
	}

	for (i=0; i<ArcNum; i++) {
		archead[i].pos += sizeof(ARCHEAD)*ArcNum+sizeof(AVGDATA_HEADER);
	}

	fp = fopen(file, "wb");
	if ( fp ) {
		// wb_o
		head->filenum = ArcNum;
		fwrite((unsigned char*)head, 1, sizeof(AVGDATA_HEADER), fp);
		fwrite((unsigned char*)archead, 1, sizeof(ARCHEAD)*ArcNum, fp);

		len = ftell(filep);
		fclose(filep);

		// e|t@Cwb_̌ɒǉ
		filep = fopen(TmpFile, "rb");
		if ( filep ) {
			while ( len>0 ) {
				if ( len>=0x100000 ) {
					fread(ArcBuf, 1, 0x100000, filep);
					fwrite(ArcBuf, 1, 0x100000, fp);
					len -= 0x100000;
				} else {
					fread(ArcBuf, 1, len, filep);
					fwrite(ArcBuf, 1, len, fp);
					len = 0;
					break;
				}
			}
			fclose(filep);
		}
		fclose(fp);
		DeleteFile(TmpFile);
	} else {
		fclose(filep);
	}
}


// A[JCuǉ
void AddArc(char* fname, unsigned char* buf, int size)
{
	ARCHEAD* head;
	int pos, newsize;

//	printf("  Adding '%s'\n", fname);

	if ( lzo1x_999_compress(buf, size, ArcBuf, &newsize, ArcWork)==LZO_E_OK ) {
		head = &archead[ArcNum];
		memset(head, 0, 32);
		pos = ftell(filep);
		head->pos = pos;
		head->size = newsize;
		head->orgsize = size;
		head->version = 2;		// kVersioniӖȂPhij
		fwrite(ArcBuf, 1, newsize, filep);
		strncpy(head->file, fname, 16);
		head->file[15] = 0;
		ConvertCapital(head->file);
		ArcNum++;
	}
}


// x^t@C̒ǉ
void ReadNORM(char* file)
{
	char *f, *p;
	FILE* fp;
	int size;
	
	fp = fopen(file, "rb");
	if ( fp ) {
		fseek(fp, 0, 2);
		size = ftell(fp);
		p = (unsigned char*)malloc(size);
		if ( p ) {
			fseek(fp, 0, 0);
			fread(p, 1, size, fp);
			fclose(fp);
			for (f=file; *f; f++) {
				if ( *f=='\\' ) file = f+1;
			}
			AddArc(file, p, size);
			free(p);
		} else {
			printf("Could not allocate memory.");
		}
	}
}

void ReadNORD(char* filename)
{
	char *f;
	char file[MAX_PATH];
	char filepath[MAX_PATH];

	strcpy(filepath, filename);
	f = filepath+(strlen(filepath));
	while ( f>=filepath ) {
		if ( *f=='\\' ) {
			*(f+1) = 0;
			break;
		}
		f--;
	}

	f = GetDir(filename);
	if ( f ) {
		sprintf(file, "%s%s", filepath, f);
		ReadNORM(file);
		while ( (f=GetDirNext())!=0 ) {
			sprintf(file, "%s%s", filepath, f);
			ReadNORM(file);
		}
	}
}

/* ----------------------------------------------------------------------
  óiSEENxxx.TXTj
---------------------------------------------------------------------- */
// 1oCgo
static void OutByte(int o)
{
	OutBuf[OutPtr++] = (unsigned char)(o&255);
	if ( OutPtr>OUT_BUFFER_SIZE ) printf("Error : OutBuffer overflow @ OutByte\n");
}


// LongIntóiLittleEndianj
static void OutInt(int o)
{
	OutBuf[OutPtr++] = (unsigned char)( o     &255);
	OutBuf[OutPtr++] = (unsigned char)((o>>8 )&255);
	OutBuf[OutPtr++] = (unsigned char)((o>>16)&255);
	OutBuf[OutPtr++] = (unsigned char)((o>>24)&255);
	if ( OutPtr>OUT_BUFFER_SIZE ) printf("Error : OutBuffer overflow @ OutInt\n");
}


// AVG32̉ϒlo
static void OutNum(int o)
{
	int i = 0;
	// 擪oCgʂ́Al̍ŉ4rbg
	OutBuf[OutPtr] = (unsigned char)(o&15);
	o >>= 4;
	i++;
	// c8rbgLittleEndianŏiő5oCgj
	while ( (i<5)&&(o) ) {
		if ( (i==4)&&(o==15) ) o = 255;
		OutBuf[OutPtr+i] = (unsigned char)(o&255);
		o >>= 8;
		i++;
	}
	// 擪oCgʂ́AoCg
	OutBuf[OutPtr] |= (i<<4);
	OutPtr += i;
	if ( OutPtr>OUT_BUFFER_SIZE ) printf("Error : OutBuffer overflow @ OutNum\n");
}


// AVG32 ϒl ԐڎQ o
// `R}hȂǂŁA萔̕ςɕϐԍŎw肷邱Ƃ\Ȃ̂Ŏg
static void OutReg(int o)
{
	int i = 0;
	// 擪oCgʂ́Al̍ŉ4rbg
	OutBuf[OutPtr] = (unsigned char)(o&15);
	o >>= 4;
	i++;
	// c8rbgLittleEndianŏiő5oCgj
	while ( (i<5)&&(o) ) {
		if ( (i==4)&&(o==15) ) o = 255;
		OutBuf[OutPtr+i] = (unsigned char)(o&255);
		o >>= 8;
		i++;
	}
	// 擪oCgʂ́AoCg|0x80
	OutBuf[OutPtr] |= (i<<4);
	OutBuf[OutPtr] |= 0x80;
	OutPtr += i;
	if ( OutPtr>OUT_BUFFER_SIZE ) printf("Error : OutBuffer overflow @ OutNum\n");
}


// o
static void OutStr(char* o)
{
	if ( (OutPtr+strlen(o)+1)>OUT_BUFFER_SIZE ) {
		printf("Error : OutBuffer overflow @ OutStr\n");
		OutBuf[OutPtr++] = 0;
	} else {
		strcpy(OutBuf+OutPtr, o);
		OutPtr += strlen(o)+1;
	}
}


/* ----------------------------------------------------------------------
  ́iSIOj
---------------------------------------------------------------------- */
// ViIt@C𐔂
static void SearchSIO(char* basedir)
{
	char *f, *file, tmpfile[MAX_PATH], tmp[MAX_PATH];
	int count = 1;

	sprintf(tmpfile, "%sMES\\*.SIO", basedir);
	f = GetDir(tmpfile);
	while ( f ) {
		for (file=f; *f; f++) {
			if ( *f=='\\' ) file = f+1;
		}
		strcpy(SIO[count], file);
		ConvertCapital(SIO[count]);

		// MAIN.SIO ASEEN001.TXTƒu
		if ( (!strcmp(SIO[count], "MAIN.SIO"))&&(count!=1) ) {
			strcpy(tmp, SIO[1]);
			strcpy(SIO[1], SIO[count]);
			strcpy(SIO[count], tmp);
		}
		count++;
		f = GetDirNext();
	}
	MaxSeen = count-1;
}


// BigEndian2oCgl擾
static int GetShort(void)
{
	int ret;
	ret  = SIOBuf[SIOPtr  ]<<8;
	ret += SIOBuf[SIOPtr+1];
	SIOPtr += 2;
	return ret;
}


// BigEndian3oCgl擾
static int GetLong(void)
{
	int ret;
	ret  = SIOBuf[SIOPtr  ]<<16;
	ret += SIOBuf[SIOPtr+1]<<8;
	ret += SIOBuf[SIOPtr+2];
	SIOPtr += 3;
	return ret;
}


/* ----------------------------------------------------------------------
  R}hƂ̕ϊ
---------------------------------------------------------------------- */
// $01 : Local Jump
static void Dec01(void)
{
	int idx;
	idx = GetShort();
	OutByte(0x1c);
	Jmps[JmpMax].in  = idx;
	Jmps[JmpMax].out = OutPtr;
	JmpMax++;
	OutInt(0);		// _~[̃Wv
	LOG("Local Jump to 0x%04X\n", idx);
}


// $02 : Global Jump
static void Dec02(void)
{
	int i;
	char name[32], *s = (char*)(SIOBuf+SIOPtr);
	OutByte(0x16);
	OutByte(0x01);
	strncpy(name, s, 32);
	ConvertCapital(name);
	for (i=1; i<=MaxSeen; i++) {
		if ( !strcmp(SIO[i], name) ) {
			OutNum(i);
			break;
		}
	}
	if ( i>MaxSeen ) {
		printf("******************** Error!!! Global jump file (%s) not found\n", name);
		OutNum(0);
	}
	SIOPtr += strlen(s)+1;
	LOG("Global Jump to %s\n", s);
}


// $03 : Get random num
static void Dec03(void)
{
	int idx, val, type;
	type = SIOBuf[SIOPtr++];
	idx = GetShort();
	val = GetLong();
	if ( type==2 ) idx += 1000;			// Global Flag
	if ( val>=0x10000 ) {				// ϐQ
		if ( val>=0x20000 ) val += 1000;
		val &= 0xffff;
		OutByte(0x49);
		OutNum(800);
		OutNum(val);
		OutByte(0x3d);
		OutNum(800);
		OutNum(1);
		OutByte(0x57);
		OutNum(idx);
		OutNum(0);
		OutReg(800);
		LOG("Val[%d($%06X)] = Rand(0-(Val[%d]-1))\n", idx, idx, val, val);
	} else {
		OutByte(0x57);
		OutNum(idx);
		OutNum(0);
		OutNum(val-1);
		LOG("Val[%d($%06X)] = Rand(0-%d)\n", idx, idx, val-1, val-1);
	}
}


// $05 : Ending
static void Dec05(void)
{
	int idx;
	idx = GetShort();
	// 0`2A0=Ń^Cg֖߂A1/2=EndingMovie1/2
	OutByte(0x0b);		// CG Macro Clear
	OutByte(0x30);
	OutByte(0x59);		// 
	OutByte(0x01);
	OutNum(1);			// ݕ\Ăwif[^oĂiStr#1j
	OutStr("NO");
	OutByte(0x0b);		// LoadEffect
	OutByte(0x05);
	OutByte((int)'@');	// t@C'@1'
	OutNum(1);
	OutNum(0);			// GtFNgԍ
	OutByte(0x16);
	OutByte(0x01);
	OutNum(998);
	LOG("Ending (%d)\n", idx);
}


// $07 : SubWindow Control
static void Dec07(void)
{
	int idx, data;
	static const char* item[] = {"Status", "Date"};
	static const char* sw[] = {"OFF", "ON"};
	idx  = GetShort();
	data = GetShort();
	if ( idx ) {
		if ( data ) {			// Disp Date
			OutByte(0x0b);		// Load PDT
			OutByte(0x10);
			OutStr("WINDOW");
			OutNum(2);
			OutByte(0x64);		// Make Color mask
			OutByte(0x10);
			OutNum(15);
			OutNum(15);
			OutNum(157);
			OutNum(41);
			OutNum(-1);
			OutNum(165);
			OutNum(166);
			OutNum(189);
			OutByte(0x67);		// MaskCopy
			OutByte(0x02);
			OutNum(320);
			OutNum(0);
			OutNum(471);
			OutNum(35);
			OutNum(2);
			OutNum(10);
			OutNum(10);
			OutNum(-1);
			OutNum(0);
			OutByte(0x0b);		// Load PDT
			OutByte(0x10);
			OutStr("OTHER_01");
			OutNum(2);
			OutByte(0x67);		// Disp Numbers (Month)
			OutByte(0x21);
			OutNum(2);			// \鐔l̓Ăϐԍ
			OutNum(0);			// f[^̊{ʒu
			OutNum(24);
			OutNum(24);			// 1ӂ̃TCY
			OutNum(24);
			OutNum(24);			// ړ
			OutNum(0);
			OutNum(2);			// Src PDT
			OutNum(26);			// \Jnʒu
			OutNum(17);
			OutNum(24);			// \ړ
			OutNum(0);
			OutNum(2);
			OutNum(1);
			OutNum(-1);
			OutNum(0);
			OutByte(0x67);		// Disp Numbers (Month)
			OutByte(0x21);
			OutNum(3);			// \鐔l̓Ăϐԍ
			OutNum(0);			// f[^̊{ʒu
			OutNum(24);
			OutNum(24);			// 1ӂ̃TCY
			OutNum(24);
			OutNum(24);			// ړ
			OutNum(0);
			OutNum(2);			// Src PDT
			OutNum(97);			// \Jnʒu
			OutNum(17);
			OutNum(24);			// \ړ
			OutNum(0);
			OutNum(2);
			OutNum(1);
			OutNum(-1);
			OutNum(0);
			OutByte(0x67);		// Copy
			OutByte(0x01);
			OutNum(10);
			OutNum(10);
			OutNum(161);
			OutNum(45);
			OutNum(0);
			OutNum(10);
			OutNum(10);
			OutNum(0);
		} else {				// Hide Date
			OutByte(0x67);		// Copy
			OutByte(0x01);
			OutNum(10);
			OutNum(10);
			OutNum(161);
			OutNum(45);
			OutNum(1);
			OutNum(10);
			OutNum(10);
			OutNum(0);
		}
	} else {
		if ( data ) {			// Disp State
			OutByte(0x16);		// Call #955
			OutByte(0x02);
			OutNum(995);
		} else {
			OutByte(0x67);		// Copy
			OutByte(0x01);
			OutNum(490);
			OutNum(14);
			OutNum(631);
			OutNum(145);
			OutNum(1);
			OutNum(490);
			OutNum(14);
			OutNum(0);
		}
	}
	LOG("SubWindow Control  %s=%s\n", item[((idx)?1:0)], sw[((data)?1:0)]);
}


// $08 : Map Position Set
static void Dec08(void)
{
	int i, pos;
	static const char* chr[]={"","䂤","݂Ȃ","m","^","","O","\Z","XeB"};
	// ꏊ͑̂ŃRgł̂݋LqB
	// 1`131FA21`312F
	// 1:_ގ  2:󂫕  3:l  4:  5:  6:L  7:rO
	// 8:_CjO  9:Lb`  10:C  11:gC  12:  13:R
	// 21:  22:O  23:݂Ȃݎ  24:󂫕  25:  26:^Ꭹ  27:m
	// 28:䂤Ў  29:gC  30:L  31:x_
	LOG("Map Position Set   ");
	for (i=0; i<9; i++) {
		pos = GetShort();
		OutByte(0x3b);		// V[41]`V[49] ɊeL̋ꏊ͗l
		OutNum(41+i);		// ̃R}hgȂĂALϐ𒼒@œoꏊύX\
		OutNum(pos);
		LOG("%s:%d  ", chr[i], pos);
	}
	// ꏊ̃Zbĝ݁B}bvIʂ$09R}hŃX^[g
	LOG("\n");
}


// $09 : Map Select
static void Dec09(void)
{
	LOG("Map Select\n");
	OutByte(0x16);		// Call #996iȂ邷ՂƁj
	OutByte(0x02);
	OutNum(996);
	// Ԓl̓LN^No.i1`9j Val[0] ɓBuIvI255B
}


// $0A : Set Title
static void Dec0A(void)
{
	char* s = (char*)(SIOBuf+SIOPtr);

	OutByte(0x59);		// 
	OutByte(0x01);
	OutNum(5);			// ^CgoĂiStr#5j
	if ( !strncmp(s, "R", 6) ) 		// XeB̃ViIŁuRvJûh
		OutStr(s+8);
	else
		OutStr(s);
	OutByte(0x60);		// Set Window Title
	OutByte(0x04);
	OutByte(0x10);		// ReadFormattedTextp̂܂Ȃ
	OutByte(0x03);		// Str#6
	OutNum(6);
	OutByte(0x10);		// ReadFormattedTextp̂܂Ȃ
	OutByte(0x03);		// Str#5
	OutNum(5);
	OutByte(0x00);		// ReadFormattedTextp̂܂Ȃ
	SIOPtr += strlen(s)+1;

	LOG("Set Title : %s\n", s);
}


// $0B : Dxő̃LN^𓾂
static void Dec0B(void)
{
	int loop, ptr;
	// Dxő̃LN^́ADxϐԍi21`28j Val[0] ɕԂ
	OutByte(0x3b);		// Val[800] = 22
	OutNum(800);
	OutNum(22);
	OutByte(0x3b);		// Val[0] = 21
	OutNum(0);
	OutNum(21);
	loop = OutPtr-0x63;
	OutByte(0x49);		// Val[801] = Val[Val[800]]
	OutNum(801);
	OutReg(800);
	OutByte(0x49);		// Val[802] = Val[Val[0]]
	OutNum(802);
	OutReg(0);
	OutByte(0x15);		// if ( Val[801] > Val[802] ) Val[0] = Val[800]
	OutByte((int)'(');
	OutByte(0x52);
	OutNum(801);
	OutNum(802);
	OutByte((int)')');
	ptr = OutPtr;
	OutInt(0);
	OutByte(0x49);		// Val[0] = Val[800]
	OutNum(0);
	OutNum(800);
	OutBuf[ptr  ] = (unsigned char)( (OutPtr-0x63)     &255);
	OutBuf[ptr+1] = (unsigned char)(((OutPtr-0x63)>>8 )&255);
	OutBuf[ptr+2] = (unsigned char)(((OutPtr-0x63)>>16)&255);
	OutBuf[ptr+3] = (unsigned char)(((OutPtr-0x63)>>24)&255);
	OutByte(0x3c);		// Val[800] += 1
	OutNum(800);
	OutNum(1);
	OutByte(0x15);		// if ( Val[800] > 28 ) End
	OutByte((int)'(');
	OutByte(0x44);
	OutNum(800);
	OutNum(28);
	OutByte((int)')');
	OutBuf[OutPtr++] = (unsigned char)( loop     &255);
	OutBuf[OutPtr++] = (unsigned char)((loop>>8 )&255);
	OutBuf[OutPtr++] = (unsigned char)((loop>>16)&255);
	OutBuf[OutPtr++] = (unsigned char)((loop>>24)&255);
	LOG("Val[0] = MostImpCharNumber\n");
}


// $0C : Snow Effect
static void Dec0C(void)
{
	int idx, data;
	static const char* sw[] = {"OFF", "ON"};
	idx  = GetShort();
	data = GetShort();
	LOG("Snow Effect %s\n", sw[((data)?1:0)]);
}


// $14 : Val[n] += v
static void Dec14(void)
{
	int idx, val, type;
	type = SIOBuf[SIOPtr++];
	idx = GetShort();
	val = GetLong();
	if ( type==2 ) idx += 1000;			// Global Flag
	if ( val>=0x10000 ) {				// ϐQ
		if ( val>=0x20000 ) {
			val += 1000;
		}
		val &= 0xffff;
		OutByte(0x4a);
		OutNum(idx);
		OutNum(val);
		LOG("Val[%d($%06X)] += Val[%d($%06X)]\n", idx, idx, val, val);
	} else {
		OutByte(0x3c);
		OutNum(idx);
		OutNum(val);
		LOG("Val[%d($%06X)] += %d($%06X)\n", idx, idx, val, val);
	}
}


// $15 : Val[n] -= v
static void Dec15(void)
{
	int idx, val, type, ptr;
	type = SIOBuf[SIOPtr++];
	idx = GetShort();
	val = GetLong();
	if ( type==2 ) idx += 1000;			// Global Flag
	if ( val>=0x10000 ) {				// ϐQ
		if ( val>=0x20000 ) {
			val += 1000;
		}
		val &= 0xffff;
		OutByte(0x4b);
		OutNum(idx);
		OutNum(val);
		LOG("Val[%d($%06X)] -= Val[%d($%06X)]\n", idx, idx, val, val);
	} else {
		OutByte(0x3d);
		OutNum(idx);
		OutNum(val);
		LOG("Val[%d($%06X)] -= %d($%06X)\n", idx, idx, val, val);
	}
	OutByte(0x15);				// ŏ0i݂͑Ȃj
	OutByte((int)'(');
	OutByte(0x47);
	OutNum(idx);
	OutNum(0);
	OutByte((int)')');
	ptr = OutPtr;
	OutInt(0);
	OutByte(0x3b);
	OutNum(idx);
	OutNum(0);
	OutBuf[ptr  ] = (unsigned char)( (OutPtr-0x63)     &255);
	OutBuf[ptr+1] = (unsigned char)(((OutPtr-0x63)>>8 )&255);
	OutBuf[ptr+2] = (unsigned char)(((OutPtr-0x63)>>16)&255);
	OutBuf[ptr+3] = (unsigned char)(((OutPtr-0x63)>>24)&255);
}


// $16 : Val[n] = v
static void Dec16(void)
{
	int idx, val, type;
	type = SIOBuf[SIOPtr++];
	idx = GetShort();
	val = GetLong();
	if ( type==2 ) idx += 1000;			// Global Flag
	if ( val>=0x10000 ) {				// ϐQ
		if ( val>=0x20000 ) {
			val += 1000;
		}
		val &= 0xffff;
		OutByte(0x49);
		OutNum(idx);
		OutNum(val);
		LOG("Val[%d($%06X)] = Val[%d($%06X)]\n", idx, idx, val, val);
	} else {
		OutByte(0x3b);
		OutNum(idx);
		OutNum(val);
		LOG("Val[%d($%06X)] = %d($%06X)\n", idx, idx, val, val);
	}
	if ( idx==255 ) {
		if ( val==1 ) {
			OutByte(0x59);		// 
			OutByte(0x01);
			OutNum(6);			// LiStr#6j
			OutStr("܌@");
		} else if ( val==2 ) {
			OutByte(0x59);		// 
			OutByte(0x01);
			OutNum(6);			// LiStr#6j
			OutStr("Lߌ@");
		} else {
			OutByte(0x59);		// 
			OutByte(0x01);
			OutNum(6);			// Null
			OutStr("");
		}
		OutByte(0x60);		// Set Window Title
		OutByte(0x04);
		OutByte(0x10);		// ReadFormattedTextp̂܂Ȃ
		OutByte(0x03);		// Str#6
		OutNum(6);
		OutByte(0x10);		// ReadFormattedTextp̂܂Ȃ
		OutByte(0x03);		// Str#5
		OutNum(5);
		OutByte(0x00);		// ReadFormattedTextp̂܂Ȃ
	}
}


// $1E-$23 : Compare
static void Dec1E(void)
{
	int idx, val, jmpt, jmpf, cond, type;
	static const char* condstr[]={"==","!=",">=","<=","> ","< "};
	static const int cmds[]={0x3b, 0x3a, 0x46, 0x47, 0x44, 0x45};	// AVG32ւ̑Ή
	static const int cmds2[]={0x49, 0x48, 0x54, 0x55, 0x52, 0x53};	// ϐQƎ

	cond = SIOBuf[SIOPtr-1]-0x1e;
	type = SIOBuf[SIOPtr++];
	idx  = GetShort();
	val  = GetLong();
	jmpt = GetShort();
	if ( SIOBuf[SIOPtr]==0xff ) {
		jmpf = SIOPtr+1;
	} else {
		jmpf = GetShort();
	}
	SIOPtr++;

	if ( type==2 ) idx += 1000;			// Global Flag
	OutByte(0x15);				// 
	OutByte((int)'(');			// AVG32ł́ATrueȂ玟R}hAFalseȂWvȂ̂Œ
	if ( val>=0x10000 ) {				// ϐQ
		OutByte(cmds2[cond]);
		if ( val>=0x20000 ) {
			val += 1000;
		}
		val &= 0xffff;
		LOG("Condition Jump   if Val[%d($%06X)]%sVal[%d($%06X)] 0x%04X else 0x%04X\n", idx, idx, condstr[cond&7], val, val, jmpt, jmpf);
	} else {
		OutByte(cmds[cond]);
		LOG("Condition Jump   if Val[%d($%06X)]%s%d($%06X) 0x%04X else 0x%04X\n", idx, idx, condstr[cond&7], val, val, jmpt, jmpf);
	}
	OutNum(idx);
	OutNum(val);
	OutByte((int)')');
	Jmps[JmpMax].in  = jmpf;
	Jmps[JmpMax].out = OutPtr;
	JmpMax++;
	OutInt(0);					// _~[iFlasej
	OutByte(0x1c);
	Jmps[JmpMax].in  = jmpt;
	Jmps[JmpMax].out = OutPtr;
	JmpMax++;
	OutInt(0);					// _~[iTruej
}


// $28 : Select
static void Dec28(void)
{
	int num = 0, i;
	int jmp[16];
	char* s;

	OutByte(0x58);		// Select
	OutByte(0x01);		// ʑ
	OutNum(999);		// Val[1000]Ɍ
	OutByte(0x22);		// AVG32ł̂܂ȂiIACeJnj
	OutByte(0);			// 
	LOG("Select\n");
	while ( SIOBuf[SIOPtr]!=0xff ) {
		jmp[num++] = GetShort();
		s = (char*)(SIOBuf+SIOPtr);
		OutByte(0xff);	// tH[}bgtȂ̂
		OutStr(s);
		OutByte(0);		// tH[}bgtȂ̂01Kv
		SIOPtr += strlen(s)+1;
		LOG("    '%s' -> 0x%04X\n", s, jmp[num-1]);
	}
	OutByte(0x23);		// AVG32ł̂܂ȂiIACeIj

	OutByte(0x1e);		// Table Jump
	OutByte(num);		// 
	OutNum(999);		// Val[999]̒lŕ
	for (i=0; i<num; i++) {
		Jmps[JmpMax].in  = jmp[i];
		Jmps[JmpMax].out = OutPtr;
		JmpMax++;
		OutInt(0);		// _~[̃Wv
	}
	SIOPtr++;
}


// $29 : Switch-Case
//     if (Val[idx]!=data1) else <address1>
//     if (Val[idx]!=data2) else <address2>
//     if (Val[idx]!=data3) else <address3>
//        ...
//     ̌`ɒu
static void Dec29(void)
{
	int num, type, idx, val;

	type = SIOBuf[SIOPtr++];
	num  = GetShort();
	if ( type==2 ) num += 1000;			// Global Flag
	LOG("Switch Val[%d($%04X)]\n", num, num);
	while ( SIOBuf[SIOPtr]!=0xff )
	{
		idx  = GetShort();
		val  = GetLong();

		OutByte(0x15);				// 
		OutByte((int)'(');
		if ( val>=0x10000 ) {		// ϐQ
			OutByte(0x48);
			if ( val>=0x20000 ) {
				val += 1000;
			}
			val &= 0xffff;
			LOG("    case Val[%d($%06X)] : Go to 0x%04X\n", val, val, idx);
		} else {
			OutByte(0x3a);
			LOG("    case %d($%06X) : Go to 0x%04X\n", val, val, idx);
		}
		OutNum(num);
		OutNum(val);
		OutByte((int)')');
		Jmps[JmpMax].in  = idx;		// 𖞂Ȃ΁iVal[num]==valȂ΁jWv
		Jmps[JmpMax].out = OutPtr;
		JmpMax++;
		OutInt(0);					// _~[
	}
	SIOPtr++;
}


// $32 : Play BGM
static void Dec32(void)
{
	int idx;
	char f[16];
	idx = GetShort();
	sprintf(f, "BGM_%02d", idx);
	OutByte(0x0e);		// Play CDDA
	OutByte(0x01);
	OutStr(f);
	LOG("Play BGM #%d\n", idx);
}


// $33 : Stop BGM
static void Dec33(void)
{
	OutByte(0x0e);		// FadeOut CDDA
	OutByte(0x10);
	OutNum(100);
	LOG("Stop BGM\n");
}


// $34 : Play WAV
static void Dec34(void)
{
	int idx;
	idx = GetShort();
	OutByte(0x0e);		// Play WAV
	OutByte(0x30);
	OutStr((char*)WAVTable[idx]);
	LOG("Play WAV #%d (%s)\n", idx, WAVTable[idx]);
}


// $35 : Play Voice
static void Dec35(void)
{
	char* s = (char*)(SIOBuf+SIOPtr);
	SIOPtr += strlen(s)+1;
	// ł͖
	LOG("Play Voice : %s\n", s);
}


// $3C : Display Charactor
static void Dec3C(void)
{
	int i, n, idx, count = 0, numptr, x = 0, step = 0;
	int chr, face, body;
	char tmp[16];
	static const char* chrs[] = {
		"SAT", "AIN", "YUU", "MIN", "CHI", "MAY", "MIO", "KAO",
		"IZA", "LIS", "NOZ", "YUK", "NAN", "HIT", "MIK", "",
		"MIA", "",    "",    "",    "",    "YUI", "KOT", "IZU",
		"SAK", "YUN", "NAS", "SIN", "COS", "YKI", "KTR", "HIN",
		"CO2", "YK2"
	};

	n = SIOBuf[SIOPtr++];
	LOG("Disp Charactor(%d) : \n", n);

	if ( n==1 ) {
		x = 120;
		step = 0;
	} else if ( n==2 ) {
		x = 0;
		step = 240;
	} else {
		printf("********** Bad charactor nums : %d\n", n);
	}

	OutByte(0x0b);		// CG Macro Clear
	OutByte(0x30);
	OutByte(0x0b);
	OutByte(0x22);
	numptr = OutPtr;
	OutByte(0);			// u
	OutByte((int)'@');	// t@C = '@1'
	OutNum(1);
	OutNum(2);			// GtFNgԍ

	for (i=0; i<n; i++) {
		idx  = GetShort()<<16;
		idx += GetShort();
		chr  = idx/10000;
		face = (idx%10000)/100;
		body = (idx%100)*10;
		if ( chr<21 ) {
			if ( chr==6 ) {			// 
				switch ( face/10 ) {
					case 0: body+=1; face=(face%10);    break;
					case 1: body+=1; face=(face%10);    break;
					case 2: body+=2; face=(face%10);    break;
					case 3: body+=3; face=(face%10)+20; break;
					case 4: body+=4; face=(face%10)+20; break;
					case 5: body+=1; face=(face%10)+10; break;
					case 6: body+=3; face=(face%10)+10; break;
					case 7: body+=3; face=(face%10)+30; break;
					case 8: body+=4; face=(face%10)+30; break;
					default:
						printf("********** Bad charactor ID : %d (%d %d %d)\n", idx, chr, face, body);
						break;
				}
			} else if ( chr==8 )						{			// \Z
				body = face;
				if ( face<10 ) body += 10;
			} else if ( (chr==0)||(chr==15) ) {						// c̊Ȃg
				body = face;
			} else {
				switch ( face/10 ) {
					case 0: body+=1; face=(face%10);    break;
					case 1: body+=1; face=(face%10);    break;
					case 2: body+=2; face=(face%10)+20; break;
					case 3: body+=3; face=(face%10);    break;
					case 4: body+=4; face=(face%10)+20; break;
					default:
						printf("********** Bad charactor ID : %d (%d %d %d)\n", idx, chr, face, body);
						break;
				}
			}
			LOG("  Charactor ID : %d (%d %d %d)   %s\n", idx, chr, face, body, chrs[chr]);

			if ( (chr!=0)&&(chr!=8)&&(chr!=15) ) {		// 3l͊炪i
				sprintf(tmp, "%s_F%02d", chrs[chr], face);
				OutByte(3);
				OutStr(tmp);
				OutNum(0);
				OutNum(0);
				OutNum(399);
				OutNum(479);
				OutNum(x);
				OutNum(0);
				count++;
			}
			sprintf(tmp, "%s_B%03d", chrs[chr], body);
			OutByte(3);
			OutStr(tmp);
			OutNum(0);
			OutNum(0);
			OutNum(399);
			OutNum(479);
			OutNum(x);
			OutNum(0);
			count++;
			x += step;
		} else {		// ƂnP̃LƂAVKLƂ
			sprintf(tmp, "%s_%02d", chrs[chr], face);
			OutByte(3);
			OutStr(tmp);
			OutNum(0);
			OutNum(0);
			OutNum(399);
			OutNum(479);
			OutNum(x);
			OutNum(0);
			count++;
			x += step;
		}
	}
	OutBuf[numptr] = count;
	LOG("\n");
}


// $3D : Hide Charactor
static void Dec3D(void)
{
	OutByte(0x0b);		// CG Macro Clear
	OutByte(0x30);
	OutByte(0x0b);		// LoadEffect
	OutByte(0x05);
	OutByte((int)'@');	// t@C'@1'
	OutNum(1);
	OutNum(2);			// GtFNgԍ
	LOG("Hide Charactor\n");
}


// $3E : Display BG
static void Dec3E(void)
{
	char name[32], *s = (char*)(SIOBuf+SIOPtr);

	strncpy(name, s, 32);
	ConvertCapital(name);
	CutExt(name);
	OutByte(0x0b);		// CG Macro Clear
	OutByte(0x30);
	OutByte(0x59);		// 
	OutByte(0x01);
	OutNum(1);			// ݕ\Ăwif[^oĂiStr#1j
	OutStr(name);
	OutByte(0x0b);		// LoadEffect
	OutByte(0x05);
	OutByte((int)'@');	// t@C'@1'
	OutNum(1);
	OutNum(2);			// GtFNgԍ
	SIOPtr += strlen(s)+1;
	LOG("DrawBG : %s\n", s);
}


// $3F : Clear BG
static void Dec3F(void)
{
	OutByte(0x0b);		// CG Macro Clear
	OutByte(0x30);
	OutByte(0x59);		// 
	OutByte(0x01);
	OutNum(1);			// ݕ\Ăwif[^oĂiStr#1j
	OutStr("NO");
	OutByte(0x68);		// FillRect
	OutByte(0x01);
	OutNum(1);
	OutNum(0);
	OutNum(0);
	OutNum(0);
	OutByte(0x0b);		// LoadEffect
	OutByte(0x05);
	OutStr("*");
	OutNum(2);			// GtFNgԍ
	LOG("Clear Screen\n");
}


// $F0 : Text
// L   "F" = O؂A"" = n[gA"c" = "..."
static void DecF0(void)
{
	unsigned char buf[1024], *d;
	unsigned char *src = (SIOBuf+SIOPtr), *s;

	d = buf;
	s = src;

	if ( *s ) {
		while ( *s ) {
			if ( (s[0]==0x81)&&(s[1]==0xa1) ) {				// n[giOPj
				*d++ = 0x81;
				*d++ = 0x96;
				*d++ = 0x82;
				*d++ = 0x4f;
				*d++ = 0x82;
				*d++ = 0x50;
			} else if ( (s[0]==0x81)&&(s[1]==0x63) ) {		// ciOQj
				*d++ = 0x81;
				*d++ = 0x96;
				*d++ = 0x82;
				*d++ = 0x4f;
				*d++ = 0x82;
				*d++ = 0x51;
			} else if ( (s[0]==0x81)&&(s[1]==0x46) ) {			// F
//				*d++ = s[0];
//				*d++ = s[1];
				*d++ = 0x81;
				*d++ = 0x6c;
				*d++ = 0;
				OutByte(0xff);
				OutByte(0x81);
				OutByte(0x6b);
				OutStr(buf);
				OutByte(0x02);
				OutByte(0x01);
				d = buf;
				*d++ = 0x81;
				*d++ = 0x79;
				*d++ = 0x81;
				*d++ = 0x7a;
//			} else if ( (s[0]==0x81)&&(s[1]==0x40) ) {		// Xy[X
			} else {
				*d++ = s[0];
				*d++ = s[1];
			}
			s += 2;
		}
		*d = 0;
		if ( d!=buf ) {
			OutByte(0xff);
			OutStr(buf);
			OutByte(0x01);
		}
		SIOPtr += strlen(src)+1;
		LOG("Text : %s\n", src);
	} else {
		SIOPtr++;
	}
}


/* ----------------------------------------------------------------------
  eSIOSEENxxx.TXTɕϊ
---------------------------------------------------------------------- */
static void DecodeSIO(int len)
{
	unsigned char c;
	int i, j;

	// 
	memcpy(OutBuf, SeenBase, 0x63);
	SIOPtr = 0;
	OutPtr = 0x63;
	JTMax = JmpMax = 0;

	// R}hPʂŕϊ
	while (SIOPtr<len) {
		// [JWvpɁAR}h̐擪ƂɈʒuLĂ
		JmpTable[JTMax].in  = SIOPtr;
		JmpTable[JTMax].out = OutPtr;
		LOG("%04X :  ", JmpTable[JTMax].in);
		JTMax++;
		c = SIOBuf[SIOPtr++];
		switch ( c ) {
			case 0x01:		// Local Jump
				Dec01();
				break;
			case 0x02:		// Global Jump
				Dec02();
				break;
			case 0x03:		// Random number
				Dec03();
				break;
			case 0x05:		// Ending
				Dec05();
				break;
			case 0x07:		// SubWindow Control
				Dec07();
				break;
			case 0x08:		// Map Position Set
				Dec08();
				break;
			case 0x09:		// Map Select
				Dec09();
				break;
			case 0x0a:		// Set Title
				Dec0A();
				break;
			case 0x0b:		// Most Imp. Charactor
				Dec0B();
				break;
			case 0x0c:		// Snow Effect
				Dec0C();
				break;
			case 0x14:		// Add Value
				Dec14();
				break;
			case 0x15:		// Sub Value
				Dec15();
				break;
			case 0x16:		// Set Value
				Dec16();
				break;
			case 0x1E:		// Compare
			case 0x1F:
			case 0x20:
			case 0x21:
			case 0x22:
			case 0x23:
				Dec1E();
				break;
			case 0x28:		// Select
				Dec28();
				break;
			case 0x29:		// Switch-Case
				Dec29();
				break;
			case 0x32:		// Play BGM
				Dec32();
				break;
			case 0x33:		// Stop BGM
				Dec33();
				break;
			case 0x34:		// Play WAV
				Dec34();
				break;
			case 0x35:		// Play Voice
				Dec35();
				break;
			case 0x3C:		// Disp Char
				Dec3C();
				break;
			case 0x3D:		// Hide Char
				Dec3D();
				break;
			case 0x3e:		// Load BG
				Dec3E();
				break;
			case 0x3f:		// Clear BG
				Dec3F();
				break;
			case 0xf0:		// Text
				DecF0();
				break;
			default:		// Unknown Cmd
				Terminate = 1;
				printf("*************** Unkown Command 0x%02X\n\n", c);
				printf("ϊɎs܂.\n");
				break;
		}
	}

	// [JWviȂj
	for (j=0; j<JmpMax; j++) {
		for (i=0; i<JTMax; i++) {
			if ( Jmps[j].in==JmpTable[i].in ) {
				OutBuf[Jmps[j].out+0] = (unsigned char)( (JmpTable[i].out-0x63)     &255);
				OutBuf[Jmps[j].out+1] = (unsigned char)(((JmpTable[i].out-0x63)>>8 )&255);
				OutBuf[Jmps[j].out+2] = (unsigned char)(((JmpTable[i].out-0x63)>>16)&255);
				OutBuf[Jmps[j].out+3] = (unsigned char)(((JmpTable[i].out-0x63)>>24)&255);
				break;
			}
		}
		if ( (i>=JTMax)&&(Jmps[j].in<len) ) {
			// WvG[ AViIւ̃Wvs͕񍐂Ȃ
			printf("******************* Jump point (0x%04x) not found!!!!!\n", Jmps[j].in);
		}
	}

	// wb_Ƀt@CTCYigĂȂǁj
	OutBuf[0x5f] = (unsigned char)( (OutPtr-0x63)     &255);
	OutBuf[0x60] = (unsigned char)(((OutPtr-0x63)>>8 )&255);
	OutBuf[0x61] = (unsigned char)(((OutPtr-0x63)>>16)&255);
	OutBuf[0x62] = (unsigned char)(((OutPtr-0x63)>>24)&255);
}


static void ConvSIO(char* basedir)
{
	int i;
	FILE* fp;
	char file[MAX_PATH];
	long pos;

	for (i=1; i<=MaxSeen; i++) {
		sprintf(file, "%sMES\\%s", basedir, SIO[i]);
		fp = fopen(file, "rb");
		if ( fp ) {
			fseek(fp, 0, 2);
			pos = ftell(fp);
			// 0oCgSIOt@Ĉ
			if ( pos ) {
				fseek(fp, 0, 0);
				fread(SIOBuf, 1, pos, fp);
				fclose(fp);
				LOG("\n\n####################################################\n");
				LOG("%s (%dbytes) -> SEEN%03d.TXT\n", SIO[i], pos, i);
				LOG("####################################################\n");
				DecodeSIO(pos);
				if ( Terminate ) return;
#if 0		// SEENxxx.TXTmFp
if ( /*OutPtr!=0x63*/i==1 ) {
char fn[256];
FILE* f;
sprintf(fn, "SEEN%03d.TXT", i);
f = fopen(fn, "wb");
fwrite(OutBuf, 1, OutPtr, f);
fclose(f);
}
#endif

				sprintf(file, "SEEN%03d.TXT", i);
				AddArc(file, OutBuf, OutPtr);
			} else {
				// 0oCgSIO̎̓XLbv
				fclose(fp);
			}
		}
	}
}



#define OUT_PIXEL	\
	if ( (d-out)>=(xsize*ysize*3) ) { err = 1; goto moe_exit; }	\
	else if ( m<out ) { err = 1; goto moe_exit; }	\
	*d++ = *m++;	\
	*d++ = *m++;	\
	*d++ = *m++;

#define OUT_PIXEL2	\
	if ( (d-out)>=(xsize*ysize*3) ) { err = 1; goto moe_exit; }	\
	else if ( m>=(in+size) ) { err = 1; goto moe_exit; }	\
	*d++ = *m++;	\
	*d++ = *m++;	\
	*d++ = *m++;

/* ----------------------------------------------------------------------
  MOEt@C̃fR[h
---------------------------------------------------------------------- */
unsigned char* DecodeMOE(char* f, int* outx, int* outy)
{
	int xsize, ysize, x, y, mask, i, n, err = 0;
	long size;
	unsigned char *in = 0, *out = 0, *dst = 0, *d, *s, *m;
	unsigned char tmp[160];
	FILE* fp;

	// t@Cǂݍ݁`
	fp = fopen(f, "rb");
	if ( fp ) {
		fseek(fp, 0, 2);
		size = ftell(fp);
		if ( size ) {
			in = (unsigned char*)malloc(size);
			if ( in ) {
				fseek(fp, 0, 0);
				fread(in, 1, size, fp);
				fclose(fp);
			}
		} else {
			fclose(fp);
		}
	}
	if ( !in ) return 0;					// ǂݍ݂ςɂ

	// ---------- fR[h ----------
	xsize = in[0]+(in[1]<<8);
	ysize = in[2]+(in[3]<<8);
	if ( (xsize==0x4d4d)&&(ysize==0x1a44) ) {		// uMMDvŎn܂̂̓tH[}bgႤɂ
		// MMDt@C
		unsigned char *blk1, *blk2, *blk3, *blk4;
		int b1 = 0, b2 = 0, b3 = 0;
		int table[16] = {				// s[ge[u
			0x0000, 0x0002, 0x0004, 0x0008, 0x0100, 0x0102, 0x0200, 0x0202,
			0x0204, 0x0400, 0x0402, 0x0404, 0x0800, 0x0802, 0x0804, 0x1000
		};

		xsize = in[4]+(in[5]<<8);		// MMDwb_̎TCY
		ysize = in[6]+(in[7]<<8);
		s = in+0x18;					// f[^Jn_
		blk1 = s;						// x[Xf[^
		blk2 = s+in[0x08]+(in[0x09]<<8)+(in[0x0a]<<16)+(in[0x0b]<<24);			// rbg]f[^
		blk3 = s+in[0x0c]+(in[0x0d]<<8)+(in[0x0e]<<16)+(in[0x0f]<<24);			// ڂւ̃|C^
		blk4 = blk3+in[0x10]+(in[0x11]<<8)+(in[0x12]<<16)+(in[0x13]<<24);		// 

		memset(tmp, 0, 160);			// x[XrbgNA
		mask = 0x80;
		out = (unsigned char*)malloc(xsize*ysize*3);
		if ( !out ) return 0;
		d = out;

		for (i=0; i<16; i++) {			// s[ge[u쐬
			n = table[i];
			table[i] = ((n>>8)*xsize+(n&255))&0xfffffffe;
		}

		for (y=0; y<ysize; y++) {
			for (x=0; x<(xsize>>2); x++) {		// 2pixelAnibblePʂŏ̂ŁAX/=4
				// x[Xf[^1rbgĂāA1rbg]1Ă
				if ( blk1[b1]&mask ) {
					tmp[x] = tmp[x]^blk2[b2];
					b2++;
				}
				mask >>= 1;
				if ( !mask ) {
					mask = 0x80;
					b1++;
				}
				if ( (tmp[x]>>4)&15 ) {		// nibble0ȊOiRs[j
					m = d-(table[(tmp[x]>>4)&15]*3);
					OUT_PIXEL
					OUT_PIXEL
				} else {					// nibble0iĂj
					if ( (blk3+b3)>=blk4 ) { err=1; goto moe_exit; }
					i = blk3[b3];
					m = blk4+(i*3);			// RGBe1oCg x 2pixel
					OUT_PIXEL2
					b3++;
					if ( (blk3+b3)>=blk4 ) { err=1; goto moe_exit; }
					i = blk3[b3];
					m = blk4+(i*3);
					OUT_PIXEL2
					b3++;
				}
				if ( tmp[x]&15 ) {			// nibble0ȊOiRs[j
					m = d-(table[tmp[x]&15]*3);
					OUT_PIXEL
					OUT_PIXEL
				} else {					// nibble0iĂj
					if ( (blk3+b3)>=blk4 ) { err=1; goto moe_exit; }
					i = blk3[b3];
					m = blk4+(i*3);			// RGBe1oCg x 2pixel
					OUT_PIXEL2
					b3++;
					if ( (blk3+b3)>=blk4 ) { err=1; goto moe_exit; }
					i = blk3[b3];
					m = blk4+(i*3);
					OUT_PIXEL2
					b3++;
				}
			}
		}
	} else {
		// MOEt@C ͒PȃOXk݂
		out = (unsigned char*)malloc(xsize*ysize*3);
		if ( !out ) return 0;
		s = in+4;						// TCYLq̕΂
		d = out;
		while ( s<(in+size) ) {
			n = *s;						// 1oCg擾
			if ( !(n&127) ) {			// [[͖̂͂
				break;
			} else if ( n<128 ) {		// 127ȉȂ玟1pixel̐s[g
				for (i=0; i<n; i++) {
					if ( (d-out)>=(xsize*ysize*3) ) { err=1; goto moe_exit; }		// f[^j̈S
					*d++ = s[1];
					*d++ = s[2];
					*d++ = s[3];
				}
				s += 4;
			} else {
				n -= 128;
				s++;
				for (i=0; i<n; i++) {	// 129`255́A(n-128)pixel̂܂܃Rs[
					if ( (d-out)>=(xsize*ysize*3) ) { err=1; goto moe_exit; }		// f[^j̈S
					*d++ = *s++;
					*d++ = *s++;
					*d++ = *s++;
				}
			}
		}
	}

moe_exit:
	if ( (d-out)!=(xsize*ysize*3) ) err=1;
	if ( err ) {
//		printf("*** Data error in '%s'\n", f);
	}
	free(in);			// WJI` f[^͔j


	*outx = xsize;
	*outy = ysize;
	return out;
}


/* ----------------------------------------------------------------------
  SHWt@C̃fR[hiMOEƂقړj
---------------------------------------------------------------------- */
unsigned char* DecodeSHW(char* f)
{
	int xsize, ysize, i, n, err = 0;
	long size;
	unsigned char *in = 0, *out = 0, *dst = 0, *d, *s;
	FILE* fp;

	// t@Cǂݍ݁`
	fp = fopen(f, "rb");
	if ( fp ) {
		fseek(fp, 0, 2);
		size = ftell(fp);
		if ( size ) {
			in = (unsigned char*)malloc(size);
			if ( in ) {
				fseek(fp, 0, 0);
				fread(in, 1, size, fp);
				fclose(fp);
			}
		} else {
			fclose(fp);
		}
	}
	if ( !in ) return 0;					// ǂݍ݂ςɂ

	// ---------- fR[h ----------
	xsize = in[0]+(in[1]<<8);
	ysize = in[2]+(in[3]<<8);

	out = (unsigned char*)malloc(xsize*ysize);
	if ( !out ) return 0;

	s = in+4;						// TCYLq̕΂
	d = out;
	while ( s<(in+size) ) {
		n = *s++;					// 1oCg擾
		if ( !(n&127) ) {			// [[͖̂͂
			break;
		} else if ( n<128 ) {		// 127ȉȂ玟1pixel̐s[g
			for (i=0; i<n; i++) {
				if ( (d-out)>=(xsize*ysize) )  { err=1; goto shw_exit; }		// f[^j̈S
				*d++ = s[0];
			}
			s += 1;
		} else {
			n -= 128;
			for (i=0; i<n; i++) {	// 129`255́A(n-128)pixel̂܂܃Rs[
				if ( (d-out)>=(xsize*ysize) )  { err=1; goto shw_exit; }		// f[^j̈S
				*d++ = *s++;
			}
		}
	}

shw_exit:
	if ( (d-out)!=(xsize*ysize) ) err=1;
	if ( err ) {
//		printf("*** Data error in '%s'\n", f);
	}
	free(in);			// WJI` f[^͔j
	return out;
}


/* ----------------------------------------------------------------------
  MOEt@C̃fR[h
---------------------------------------------------------------------- */
void AddMOE(char* f)
{
	int xsize, ysize, x, y, xx, yy, r, g, b, rr, gg, bb, mask, n, i, mflag = 0;
	unsigned char *out = 0, *dst = 0, *d, *s, *m;
	static const unsigned char DefHeader[] = {		// PDT̕Wwb_
		0x50, 0x44, 0x54, 0x31, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	};
	char file[MAX_PATH];

	out = DecodeMOE(f, &xsize, &ysize);

	// k
	xx = xsize>>1;
	yy = ysize>>1;
	dst = (unsigned char*)malloc(xx*yy*3+32);
	if ( dst ) {
		memset(dst, 0, xx*yy*3+32);
		if ( out ) {
			d = dst+32;
			m = dst+xx*yy*2+32;
			for (y=0; y<yy; y++) {
				s = out+y*xsize*6;
				for(x=0; x<xx; x++) {
					// P4sNZ̕ϒlĂ邾
					rr = gg = bb = 0;
					mask = 256;
					r = s[0];
					g = s[1];
					b = s[2];
					if ( (b==0)&&(g==255)&&(r==0) ) { g = 0; mask -= 64; mflag = 1; }	// ΂ߐF
					rr += r; gg += g; bb += b;
					r = s[3];
					g = s[4];
					b = s[5];
					if ( (b==0)&&(g==255)&&(r==0) ) { g = 0; mask -= 64; mflag = 1; }	// ΂ߐF
					rr += r; gg += g; bb += b;
					r = s[xsize*3+0];
					g = s[xsize*3+1];
					b = s[xsize*3+2];
					if ( (b==0)&&(g==255)&&(r==0) ) { g = 0; mask -= 64; mflag = 1; }	// ΂ߐF
					rr += r; gg += g; bb += b;
					r = s[xsize*3+3];
					g = s[xsize*3+4];
					b = s[xsize*3+5];
					if ( (b==0)&&(g==255)&&(r==0) ) { g = 0; mask -= 64; mflag = 1; }	// ΂ߐF
					rr += r; gg += g; bb += b;
					if ( mask ) mask--;			// ΁iߐFj̗ʂɉă}XN߂i0xff:߂Ȃ/0x7f/0x3f/0x00:S߁j
					*m++ = (unsigned char)(mask&255);
					rr >>= 2;
					gg >>= 2;
					bb >>= 2;

					s += 6;
					n = ((bb&0xf8)<<8)|((gg&0xfc)<<3)|((rr&0xf8)>>3);		// 5-6-5Ɋ蓖
					*((unsigned short*)d) = (unsigned short)(n&0xffff);
					d += 2;
				}
			}
			free(out);
		}
		// kIAiӂptH[}bǵjPDTɎdグ܂
		for (i=0, n=0; f[i]; i++) {
			if ( f[i]=='\\' ) n = 0;
			else if ( f[i]=='.' ) break;
			else file[n++] = f[i];
		}
		file[n] = 0;
		ConvertCapital(file);
		strcat(file, ".PDT");
		if ( !strcmp(file, "CIP_MAP.PDT") ) {	// ̃n[gĂ
			for (y=42; y<54; y++) {
				for (x=0; x<12; x++) {
					n = (dst[32+y*xx*2+x*2])+(dst[33+y*xx*2+x*2]<<8);
					r = ((n&0xf800)>>11);
					g = ((n&0x07e0)>>5);
					b =  (n&0x001f);
					r = (r*0xc0)/255;
					g = (g*0xc0)/255;
					b = (b*0xc0)/255;
					n = ((r<<11)|(g<<5)|(b));
					dst[32+(y+12)*xx*2+x*2] = (n&255);
					dst[33+(y+12)*xx*2+x*2] = (n>>8);
					if (dst[32+xx*yy*2+y*xx+x])
						dst[32+xx*yy*2+(y+12)*xx+x] = (dst[32+xx*yy*2+y*xx+x]*0xc0)/255; 
				}
			}
		}

		memcpy(dst, DefHeader, 32);			// wb_
		dst[12] = (xsize    )&255;
		dst[13] = (xsize>>8 )&255;
		dst[14] = (xsize>>16)&255;
		dst[15] = (xsize>>24)&255;
		dst[16] = (ysize    )&255;
		dst[17] = (ysize>>8 )&255;
		dst[18] = (ysize>>16)&255;
		dst[19] = (ysize>>24)&255;
		if ( mflag ) {
			dst[28] = ((xx*yy*2)    )&255;
			dst[29] = ((xx*yy*2)>>8 )&255;
			dst[30] = ((xx*yy*2)>>16)&255;
			dst[31] = ((xx*yy*2)>>24)&255;
			AddArc(file, dst, xx*yy*3+32);
		} else {		// }XNiߐFjƂ
			dst[28] = dst[29] = dst[30] = dst[31] = 0;
			AddArc(file, dst, xx*yy*2+32);
		}
#if 0		// o͊mFp
{
FILE* fm;
fm = fopen(file, "wb");
fwrite(dst, 1, xx*yy*3+32, fm);
fclose(fm);
}
#endif
		free(dst);
	}
}


/* ----------------------------------------------------------------------
  LnMOEt@C̃fR[h
---------------------------------------------------------------------- */
void AddChar(char* f, char* mf)
{
	int xsize, ysize, x, y, xx, yy, r, g, b, n, i, mn, mask;
	unsigned char *out = 0, *mout = 0, *dst = 0, *d, *s, *md, *ms;
	static const unsigned char DefHeader[] = {		// PDT̕Wwb_
		0x50, 0x44, 0x54, 0x31, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	};
	char file[MAX_PATH];

	out = DecodeMOE(f, &xsize, &ysize);
	mout = DecodeSHW(mf);
if (!mout) printf("************** Cannot open %s", mf);

	// k
	xx = xsize>>1;
	yy = ysize>>1;
	dst = (unsigned char*)malloc(xx*yy*3+32);
	memset(dst, 0, xx*yy*3+32);
	d = dst+32;
	md = dst+xx*yy*2+32;
	for (y=0; y<yy; y++) {
		s = out+y*xsize*6;
		ms = mout+y*xsize*2;
		for(x=0; x<xx; x++) {
			mask = mn  = ms[0]+(ms[0]<<4);
			r = (s[0]*mask)/255;		// AVG32͖OaẐŁA
			g = (s[1]*mask)/255;		// F}XN/255{Ă
			b = (s[2]*mask)/255;
			mask = ms[1]+(ms[1]<<4);
			mn += mask;
			r += (s[3]*mask)/255;
			g += (s[4]*mask)/255;
			b += (s[5]*mask)/255;
			mask = ms[xsize]+(ms[xsize]<<4);
			mn += mask;
			r += (s[xsize*3+0]*mask)/255;
			g += (s[xsize*3+1]*mask)/255;
			b += (s[xsize*3+2]*mask)/255;
			mask = ms[xsize+1]+(ms[xsize+1]<<4);
			mn += mask;
			r += (s[xsize*3+3]*mask)/255;
			g += (s[xsize*3+4]*mask)/255;
			b += (s[xsize*3+5]*mask)/255;
			mn >>= 2;
			r >>= 2;
			g >>= 2;
			b >>= 2;

			s += 6;
			n = ((b&0xf8)<<8)|((g&0xfc)<<3)|((r&0xf8)>>3);		// 5-6-5Ɋ蓖
			*((unsigned short*)d) = (unsigned short)(n&0xffff);
			d += 2;
			ms += 2;
			*md++ = mn;
		}
	}

	// kIAiӂptH[}bǵjPDTɎdグ܂
	for (i=0, n=0; f[i]; i++) {
		if ( f[i]=='\\' ) n = 0;
		else if ( f[i]=='.' ) break;
		else file[n++] = f[i];
	}
	file[n] = 0;
	strcat(file, ".PDT");

	memcpy(dst, DefHeader, 32);			// wb_
	dst[12] = (xsize    )&255;
	dst[13] = (xsize>>8 )&255;
	dst[14] = (xsize>>16)&255;
	dst[15] = (xsize>>24)&255;
	dst[16] = (ysize    )&255;
	dst[17] = (ysize>>8 )&255;
	dst[18] = (ysize>>16)&255;
	dst[19] = (ysize>>24)&255;
	dst[28] = ((xx*yy*2)    )&255;
	dst[29] = ((xx*yy*2)>>8 )&255;
	dst[30] = ((xx*yy*2)>>16)&255;
	dst[31] = ((xx*yy*2)>>24)&255;
	AddArc(file, dst, xx*yy*3+32);

#if 0		// o͊mFp
{
FILE* fm;
fm = fopen(file, "wb");
fwrite(dst, 1, xx*yy*3+32, fm);
fclose(fm);
}
#endif

	free(mout);
	free(out);
	free(dst);
}


// MOEt@CEfR[h
static void SearchMOE(char* basedir, char* subdir)
{
	char *f, tmpfile[MAX_PATH];

	if ( *subdir )
		sprintf(tmpfile, "%s%s\\*.MOE", basedir, subdir);
	else
		sprintf(tmpfile, "%s*.MOE", basedir);
	f = GetDir(tmpfile);
	while ( f ) {
		if ( *subdir )
			sprintf(tmpfile, "%s%s\\%s", basedir, subdir, f);
		else
			sprintf(tmpfile, "%s%s", basedir, f);
		AddMOE(tmpfile);
		f = GetDirNext();
	}
}


// Lt@CfR[h
static void SearchChar(char* basedir)
{
	char *f, tmpfile[MAX_PATH], maskfile[MAX_PATH], tmp[MAX_PATH];

	sprintf(tmpfile, "%sCHAR\\*.MOE", basedir);
	f = GetDir(tmpfile);
	while ( f ) {
		sprintf(tmpfile, "%sCHAR\\%s", basedir, f);
		strcpy(tmp, f);
		if ( (f[4]=='B')||(f[4]=='b') ) {			// 
			CutExt(tmp);
			strcat(tmp, "S.SHW");
		} else if ( (f[4]=='F')||(f[4]=='f') ) {	// 
			if ( f[5]=='1' )			// 
				tmp[5] = '0';
			else if ( f[5]=='3' )
				tmp[5] = '2';
			strcpy(tmp+6, "S.SHW");
		} else {									// ǉL
			if ( f[5]<='5' ) tmp[5] = '5';
			if ( ((f[0]=='Y')||(f[0]=='y'))&&((f[1]=='k')||(f[4]=='k')) )
				tmp[5] = '5';						// ͏5
			strcpy(tmp+6, "S.SHW");
		}
		sprintf(maskfile, "%sSHADOW\\%s", basedir, tmp);
		AddChar(tmpfile, maskfile);
		f = GetDirNext();
	}
}


/* ----------------------------------------------------------------------
  ߂
---------------------------------------------------------------------- */
void main(void)
{
	LPTSTR filepart;
	char buf[MAX_PATH];
	char AppDir[MAX_PATH];
	AVGDATA_HEADER	header;

	printf("uƂn uᔠ~jViIv f[^Ro[^ for ӂ\n");
	printf("Version %s  (c)2001, Kenjo / Damekko-House\n\n", _VERSION_);

	memset(&header, 0, sizeof(header));
	sprintf(header.id, "ZAVG32");
	sprintf(header.appname, "Ƃn uᔠ~jViI");
	header.runver = 1613;		// AVG3216MñR}hŋLq
	header.cmpver = 2;
	header.grpbit = 16;
	header.mskbit = 8;

	printf("##### uuuᔠvCXg[Ă #####\n");
	printf("##### tH_IĂB                   #####\n\n");

	// Av̋NtH_擾iAVDt@Co͐j
	GetModuleFileName(NULL, buf, MAX_PATH);
	GetFullPathName(buf, MAX_PATH, AppDir, &filepart);
	*filepart = 0;

	if( SelectBaseDir(buf) ) {
		if ( InitArc(AppDir) ) {	// A[JCuJ
			printf("... Ro[gł\n\n");
			SearchSIO(buf);			// SIOt@C擾
			ConvSIO(buf);			// Sϊ`
			if ( Terminate ) goto finish;
			SearchChar(buf);
			SearchMOE(buf, "CG");	// MOEt@C
			SearchMOE(buf, "ENDING");
			SearchMOE(buf, "SYSTEM");
			sprintf(buf, "%sDATA\\*.*", AppDir);
			ReadNORD(buf);			// ̑ǉf[^iOpӁjǉ

			// A[JCu鏈
			sprintf(buf, "%sWLK297.AVD", AppDir);
			CloseArc(buf, &header);
			printf("I܂.\n\n");
		} else {
			printf("A[JCu쐬Ɏs܂.\n\n");
		}
	} else {
		printf("~܂.\n\n");
	}

finish:
	printf("L[Ă.\n");
	while ( _getch()==0 ) {}
}
